#include <R.h>
#include <Rinternals.h>

static SEXP thefun,theenv;
double simp(double (*)(),double,double,long);

SEXP dosimp(SEXP args,SEXP function,SEXP env)
{
  double start,stop,nintvl,res;
  SEXP answer;
  double evalthefun(double);

  thefun = function;
  theenv = env;

  start = REAL(args)[0];
  stop  = REAL(args)[1];
  nintvl= REAL(args)[2];

  res = simp(evalthefun,start,stop,(long)nintvl);
  PROTECT(answer = allocVector(REALSXP,1));
  REAL(answer)[0] = res;
  UNPROTECT(1);
  return(answer);
}

double evalthefun(double x)
{
  SEXP rargs,Rcall,result;
  rargs = allocVector(REALSXP,1);
  REAL(rargs)[0] = x;

  PROTECT(Rcall = lang2(thefun,rargs));
  PROTECT(result = eval(Rcall,theenv));

  UNPROTECT(2);
  return(REAL(result)[0]);
}

  
