#include <stdio.h>
#include "math.h"
#include "mex.h"

static char *thefunction;
double simp(double(*)(),double,double,long);

EXTERN_C void mexFunction(int nls,mxArray **plhs,int nrhs,const mxArray **prhs)
{
   double stop,start,res;
   char fun[100];
   long nintvls;
   mxArray *args[1];
   double evalthefun(double);

   if(nrhs < 3){
      mexErrMsgTxt("dosimpm requires at least three arguments\n");
    }

   mxGetString(prhs[0],fun,100);
   thefunction = fun;

   start = (double)mxGetScalar(prhs[1]);
   stop = (double)mxGetScalar(prhs[2]);
   if(nrhs == 4)nintvls = (long)mxGetScalar(prhs[3]);
   else nintvls = 100;

   plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);

   res = simp(evalthefun,start,stop,nintvls);
   *mxGetPr(plhs[0]) = res;
}

double evalthefun(double x){
  mxArray *mtmp,*args[1];

  args[0] = mxCreateDoubleMatrix(1,1,mxREAL);
  mxGetPr(args[0])[0] = x;

  mexCallMATLAB(1,&mtmp,1,args,thefunction);
  return(*mxGetPr(mtmp));

}


